## piserver 0.7.3

=== CMakeLists.txt ===
project(piserver)
cmake_minimum_required(VERSION 3.1)

set (CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wno-psabi")

find_package(Gettext)
set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)
find_package(CURL REQUIRED)
find_package(LibArchive REQUIRED)
find_package(PkgConfig)
pkg_check_modules(GTKMM REQUIRED gtkmm-3.0)
link_directories(${GTKMM_LIBRARY_DIRS})
include_directories(${GTKMM_INCLUDE_DIRS})

include(CheckIncludeFile)
check_include_file(ldap.h HAVE_LDAP_H)
find_library(LDAP_LIBRARY ldap)

if(NOT HAVE_LDAP_H OR NOT LDAP_LIBRARY)
    message( FATAL_ERROR "Missing libldap. Try 'sudo apt install libldap2-dev'" )
endif()

find_library(CAP_LIBRARY cap)
check_include_file(sys/capability.h HAVE_CAPABILITY_H)
if(NOT HAVE_CAPABILITY_H OR NOT CAP_LIBRARY)
    message( FATAL_ERROR "Missing libcap. Try 'sudo apt install libcap-dev'" )
endif()

# for crypt_r()
find_library(CRYPT_LIBRARY crypt)

# for resolving SRV DNS records
find_library(RESOLV_LIBRARY resolv)

# test if we need libatomic
include(CheckCXXSourceCompiles)
check_cxx_source_compiles("
    #include <atomic>
    #include <stdint.h>
    int main() {
	std::atomic<int64_t> x;
	x = 1;
	return (int) x;
    }"
    atomicbuiltin)

if (NOT atomicbuiltin)
	find_library(ATOMIC_LIBRARY NAMES atomic libatomic.so.1)
	if (NOT ATOMIC_LIBRARY)
		message( FATAL_ERROR "Missing libatomic while architecture does need it" )
	endif()
endif()

aux_source_directory(src SRC_LIST)
add_executable(${PROJECT_NAME} ${SRC_LIST} resources.c)
target_link_libraries(${PROJECT_NAME} ${GTKMM_LIBRARIES} ${LDAP_LIBRARY}
    ${CRYPT_LIBRARY} ${RESOLV_LIBRARY} ${CURL_LIBRARY} ${LibArchive_LIBRARIES} ${CAP_LIBRARY} ${ATOMIC_LIBRARY} Threads::Threads -lstdc++fs)

# Languages

if (GETTEXT_FOUND)
    file(GLOB LANGUAGES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} po/*.po)
    GETTEXT_CREATE_TRANSLATIONS(po/piserver.pot ALL ${LANGUAGES})
    add_definitions(-DLOCALEDIR="/usr/share/locale")
endif()

# Resources

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/macros)
include(GlibCompileResourcesSupport)

set(RESOURCE_LIST
    data/firstuse.glade
    data/piserver.glade
    data/addhostdialog.glade
    data/edithostdialog.glade
    data/adduserdialog.glade
    data/edituserdialog.glade
    data/adddistrodialog.glade
    data/addfolderdialog.glade
    data/clonedistrodialog.glade
    data/ldapsettingsdialog.glade
    )

compile_gresources(RESOURCE_FILE
                   XML_OUT
                   TYPE EMBED_C
                   RESOURCES ${RESOURCE_LIST})

add_custom_target(resource ALL DEPENDS ${RESOURCE_FILE})

# Installation

install(TARGETS piserver DESTINATION bin)
install(FILES data/piserver.desktop DESTINATION share/applications)
install(FILES data/org.raspberrypi.piserver.policy DESTINATION share/polkit-1/actions)
install(DIRECTORY DESTINATION /var/lib/piserver)
install(DIRECTORY DESTINATION /var/lib/piserver/os)
install(DIRECTORY DESTINATION /var/lib/piserver/os/shared)
install(DIRECTORY DESTINATION /var/lib/piserver/tftproot)
install(DIRECTORY DESTINATION /var/lib/piserver/scripts)
install(PROGRAMS scripts/postinstall.sh scripts/convert.sh scripts/convert_folder.sh scripts/chroot_image.sh DESTINATION /var/lib/piserver/scripts)
install(FILES scripts/convert_chrooted_cmds scripts/mkhomedir-piserver DESTINATION /var/lib/piserver/scripts)
install(FILES scripts/50-piserver-dhcpcd-hook DESTINATION /lib/dhcpcd/dhcpcd-hooks)

=== debian/changelog ===
piserver (0.7.3) buster; urgency=medium

  * Fix GDateTime reference counting 

 -- Floris Bos <bos@je-eigen-domein.nl>  Sat, 03 Jul 2021 01:09:49 +0200

piserver (0.7.2) buster; urgency=medium

  * Drop file system capabilities while running chroot shell
  * Importing SD cards: copy start menu folder structure too   

 -- Floris Bos <bos@je-eigen-domein.nl>  Thu, 27 May 2021 18:33:33 +0200

piserver (0.7.1) buster; urgency=medium

  * Add support for converting OS images from SD card 

 -- Floris Bos <bos@je-eigen-domein.nl>  Thu, 29 Apr 2021 23:37:25 +0200

piserver (0.7) buster; urgency=medium

  * Add new MAC OUI
  * pxz -> xz
  * Mention Pi 4 is also supported in UI

 -- Floris Bos <bos@je-eigen-domein.nl>  Tue, 27 Apr 2021 14:38:33 +0200

piserver (0.6) buster; urgency=medium

  [ Floris Bos ]
  * Add missing return statement

 -- Serge Schneider <serge@raspberrypi.org>  Wed, 19 Feb 2020 17:36:57 +0000

piserver (0.5) buster; urgency=medium

  * Add export/save button for OS images
  * AD: support having users outside CN=users
  * LOCALE_DIR -> LOCALEDIR
  * Implement minimal download resuming support
  * Add support for lastlogin tracking, description
  * Fix mouse cursor on startup
  * Do not continously poll for SD card that usually is not present
  * Remove PubkeyAuthentication=no from pam_mount.conf.xml
  * Link to libatomic if needed
  * Fix setting /etc/nslcd.conf when using external LDAP/AD server
  * External LDAP/AD server: allow restricting access by user group
  * Warn user if STP is enabled on switch
  * Buster: fix disabling console auto-login
  * Add hosts screen: add new OUI to detection routine
  * sdtweak,pollonce -> sdtweak,poll_once
  * Buster: fix systemd-timesync time synchronization
  * Let systemd create the sshd runtime directory
  * Remove improper references to gksu
  * Remove references to Pixel

 -- Serge Schneider <serge@raspberrypi.org>  Mon, 14 Oct 2019 10:40:59 +0100

piserver (0.4) buster; urgency=medium

  * Add 'clone OS' button
  * Remove dependency on gksudo

 -- Serge Schneider <serge@raspberrypi.org>  Thu, 07 Feb 2019 10:26:54 +0000

piserver (0.3) stretch; urgency=medium

  * dhcpcd: disable link detection
  * Fix copying timezone setting from Piserver computer
  * Mount shared folders nolock
  * Shell button: call x-terminal-emulator instead of lxterminal

 -- Serge Schneider <serge@raspberrypi.org>  Tue, 03 Jul 2018 09:52:24 +0100

piserver (0.2) stretch; urgency=medium

  * Add DhcpClient. Remove dependency on odhcploc
  * Force reconfig of existing slapd
  * Add initial .csv import support
  * Workaround for warnings being printed (gtk empty string bug)
  * Force systemd reload on install
  * Update convert_chrooted_cmds for Stretch
  * Remove data files on apt-get remove --purge piserver
  * Add minimal support for external LDAP/AD servers
  * Workaround for error when running "dpkg-reconfigure slapd" twice
  * Defer home directory creation to first login
  * Set certificate date to 9999
  * Add simple shared folder support
  * Do not create /etc/dnsmasq.d/piserver if not configured

 -- Serge Schneider <serge@raspberrypi.org>  Tue, 20 Mar 2018 10:53:01 +0000

piserver (0.1) jessie; urgency=medium

  * Initial release

 -- Floris Bos <bos@je-eigen-domein.nl>  Fri, 14 Apr 2017 21:10:11 +0100

## piserver 0.7.6

=== debian/changelog ===
piserver (0.7.6) bullseye; urgency=medium

  * Add support for newer Pi with MAC-addresses that start with d8:3a:dd

 -- Floris Bos <bos@je-eigen-domein.nl>  Tue, 16 May 2023 22:04:36 +0200

piserver (0.7.5) buster; urgency=medium

  * Fix "Cannot use erase() with null" error when using
    non-ad external LDAP server

 -- Floris Bos <bos@je-eigen-domein.nl>  Sat, 10 Sep 2022 23:42:33 +0200

piserver (0.7.4) buster; urgency=medium

  * Update convert script for bullseye 

 -- Floris Bos <bos@je-eigen-domein.nl>  Tue, 23 Nov 2021 20:55:19 +0100

=== debian/control ===
Source: piserver
Section: admin
Priority: optional
Maintainer: Floris Bos <bos@je-eigen-domein.nl>
Build-Depends: debhelper (>= 9), cmake, libldap2-dev, libgtkmm-3.0-dev, libarchive-dev, libcurl4-openssl-dev, libcap-dev, intltool
Standards-Version: 3.9.7

Package: piserver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, binfmt-support [!armhf], qemu-user-static [!armhf]
Recommends: policykit-1
Description: Utility program to manage a network of diskless Pi 3 terminals
 Lets diskless Pi 3 terminals PXE boot from the network.
